
!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
custom: aPresentation
	
	self subclassResponsibility! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: 'lr 2/25/2009 14:25'!
defaultRenderer
	
	^GLMRenderer subclasses anyOne new! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
list
	
	^self custom: GLMListPresentation new! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
mondrian
	
	^self custom: GLMMondrianPresentation new! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
open
	
	^self openWith: self defaultRenderer! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
openOn: anObject
	
	^self
		openOn: anObject
		with: self defaultRenderer! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
openOn: anObject with: aRenderer
	
	self startOn: anObject.
	^aRenderer open: self! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
openWith: aRenderer
	
	^self openOn: nil with: aRenderer! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
startOn: anObject
	
	self initializeScriptingDefaults.
	self entity: anObject! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
text
	
	^self custom: GLMTextPresentation new! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
tree
	
	^self custom: GLMTreePresentation new! !

!GLMPresentation methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
display: aBlock
	
	self transformation: aBlock! !

!GLMPresentation methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
on: aCharacter do: aBlock
	
	self
		addAction:
			((GLMAction new)
				action: aBlock;
				shortcut: aCharacter;
				yourself)! !

!GLMPresentation methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
when: aBlock
	
	self condition: aBlock! !

!GLMPresentation methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
whenKindOf: aClass
	
	self when: [:each | each isKindOf: aClass]! !

!GLMCustomColumn methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
row: aBlockOrSymbol
	
	^self addRow: aBlockOrSymbol! !

!GLMCustomColumn methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
row: aBlockOrSymbol span: anInteger
	
	^self addRow: aBlockOrSymbol span: anInteger! !

!GLMTableLayoutBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
column: aBlockOrSymbol
	
	^self addColumn: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
column: aBlockOrSymbol span: anInteger
	
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMTableLayoutBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
row: aBlockOrSymbol
	
	^self addRow: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
row: aBlockOrSymbol span: anInteger
	
	^self addRow: aBlockOrSymbol span: anInteger! !

!GLMFinder methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
custom: aPresentation
	
	self addPresentation: aPresentation.
	^aPresentation! !

!GLMCustomRow methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
column: aBlockOrSymbol
	
	^self addColumn: aBlockOrSymbol! !

!GLMCustomRow methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
column: aBlockOrSymbol span: anInteger
	
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
capture: aSymbol as: aPort
	
	self capturedPorts
		add:
			((GLMPublishedPort new)
				innerPort: aPort;
				outerPortName: aSymbol;
				yourself)! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
custom: aPresentation
	
	scriptTransmission addPresentation: aPresentation.
	^aPresentation! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
from: anOriginPortReference
	
	scriptTransmission
		addActiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
passivelyFrom: anOriginPortReference
	
	scriptTransmission
		addPassiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
publish: aPort as: aSymbol
	
	self publishedPorts
		add:
			((GLMPublishedPort new)
				innerPort: aPort;
				outerPortName: aSymbol;
				yourself)! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
pull: anOuterPortSymbol to: anInnerPortReference
	
	self
		addPull: anOuterPortSymbol
		to: (self resolveOriginPort: anInnerPortReference)! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
push: anInnerPortReference as: anOuterPortSymbol
	
	self
		addPush: (self resolveOriginPort: anInnerPortReference)
		as: anOuterPortSymbol! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
sendTo: aDesinationPortReference from: anOriginPortReference
	
	self transmissions
		addLast:
			((GLMSimpleTransmission new)
				origin: (self resolveOriginPort: anOriginPortReference);
				destination: (self resolveDestinationPort: aDesinationPortReference);
				yourself)! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
showOn: aDestinationPane
	
	scriptTransmission := (GLMBundleTransmission new)
		destination: (self resolveDestinationPort: aDestinationPane);
		yourself! !

!GLMExplicitBrowser methodsFor: '*glamour-scripting' stamp: ' 25/2/09 11:51'!
using: aBlock
	
	aBlock value.
	scriptTransmission origins isEmpty
		ifTrue: [self addJumpstart: scriptTransmission]
		ifFalse: [self addTransmission: scriptTransmission].
	scriptTransmission := nil! !
